BKCommonLib

empty

BKCommonLib logo

Latest version: 1.57

CraftBukkit/SportBukkit/Spigot/MCPC+ build: CB 1.6.4 R1.0 / CB 1.6.4 R2.1 / Spigot 1.7

Older builds available: CB 1.5.2-R1.0 / CB 1.6.2-R1.0

Tekkit: Untested and thus unsupported, some features may not work as expected

Description

This utility library shares all the common code needs for various plugins, and having them in one library heavily reduces the amount of duplicated code. The featured utilities are varied, and whenever something is missing in Bukkit, it is added in BKCommonLib. This is one of the reasons why it has become this large: there are simply a lot of things Bukkit doesn't (want to) offer.

BKCommonLib has versioning on a per-plugin basis, so when a certain plugin needs version 2, and version 1 is installed, the server owner is automatically notified and the plugin is not enabled. This prevents the common mishaps with outdated BKCommonLib versions.

Other than utilities and services, this library offers a wide variety of reflection and user-friendly ways of accessing net.minecraft.server. If your plugin requires the use of the internals, but do not want to risk changing field and method names, you can depend on BKCommonLib to provide them for you. This allows you to remain compatible between CraftBukkit versions automatically, and reduces silent failure hazards.

Reasons for you to depend on this library

  • You need to access Minecraft internals in your plugin, and Bukkit has no API for it
  • You are tired of re-uploading the same version over again because of the internals changing
  • You want to work with Vector/math logic, or need to use other utility classes
  • The YAML of Bukkit dislikes you, and you want this to be easier
  • You want to easily read and write configuration/data files
  • You want easy access to data conversion utilities to convert user input
  • You want to work with inventories in an advanced fashion
  • You want to work with unique server events
  • You want to alter entity behaviour (such as handling block collisions, custom movement, etc.)
  • You want plugin messages/permissions to be configurable
  • You want to work with (async)tasks without storing IDs
  • You want to send and manipulate packets

Features

Getting started

To start using BKCommonLib, you have two options (after adding BKCommonLib as dependency in the plugin.yml):

Include the jar file as a dependency

Like any dependency, keep the jar file somewhere on your computer and add it to your classpath. Nothing special here.

Make a (new) maven project and include it

Add the following repository:

<repository>
    <id>dj-tcraft repository</id>
    <url>http://ci.dj-tcraft.nl/plugin/repository/everything/</url>
</repository>

And the following dependency (may need to update version):

<dependency>
    <groupId>com.bergerkiller.bukkit</groupId>
    <artifactId>BKCommonLib</artifactId>
    <version>1.54-SNAPSHOT</version>
    <scope>provided</scope>
</dependency>

Dependencies BKCommonLib uses

BKCommonLib supports various other plugins and projects. Below all of these are listed:

  • Vault - for permission plugin support
  • ProtocolLib - to avoid packet listening conflicts
  • Showcase(Standalone) - to ignore showcased items
  • HyperConomy - to ignore shop items
  • BleedingMobs - to ignore particles
  • CGLib - for generating nms.Entity classes on-the-fly to supply Entity Controllers
  • Objenesis - for generating classes without calling constructors (needed for various fixes inside class constructors)

Plugins that require BKCommonLib to be installed:

Disclaimer

This plugin utilises Hidendra's plugin metrics system, which means that the following information is collected and sent to mcstats.org:

  • A unique identifier
  • The server's version of Java
  • Whether the server is in offline or online mode
  • The plugin's version
  • The server's version
  • The OS version/name and architecture
  • The core count for the CPU
  • The number of players online
  • The Metrics version Opting out of this service can be done by editing plugins/Plugin Metrics/config.yml and changing opt-out to true.

License

This library uses an open license. Feel free to use whatever code you need from it, you do not have to ask me either. If you want me to add certain features, that is fine too. Everyone is allowed to use this Library as a dependency. I do recommend extending 'PluginBase' instead of 'JavaPlugin' then, as it allows you to automatically deal with the BKCommonLib versioning checks. See also: BKCommonLib license file

This product includes software developed by the Apache Software Foundation (http://www.apache.org/)

Compatibility

BKCommonLib supports ProtocolLib when it is enabled, but if it is not, the player connection is replaced resulting in several incompatibilities. To fix these incompatibility issues, install ProtocolLib next to BKCommonLib. This can not be stressed enough. When incompatibility occurs, BKCommonLib will notify you in the console and will disable itself. The following plugins are known to be incompatible when ProtocolLib is NOT installed:

Metrics

This plugin sends server count and dependency statistics to MCStats.org. You can (globally) opt out in the PluginMetrics/config.yml file.

Banner

I use a banner in my depending plugins. This banner is automatically updated when a new version of BKCommonLib is out. It is a quick and efficient way to keep track of updates for this library. This was needed, too, because a lot of people were using outdated BKCommonLib versions, which resulted in bug reports...too many of them. And I do not want to waste your time with invalid reports. You have a plugin that uses BKCommonLib? Feel free to use the banner on your download page.

[[http://dev.bukkit.org/bukkit-plugins/bkcommonlib/|{{http://ci.dj-tcraft.nl/job/BKCommonLib/lastSuccessfulBuild/artifact/target/BKCommonLibVersion.png|Go to the BKCommonLib Dev-bukkit page}}]]

Development Builds

DevBukkit Disclaimer
Click here to Download development builds of this Plugin

Go to the BKCommonLib Dev-bukkit page

Click here to add this banner to your page
How to place useful comments How to install plugins Solving errors and when to report them Reading and writing YAML

You must login to post a comment. Don't have an account? Register to get one!

  • Avatar of dockter dockter Nov 16, 2014 at 05:42 UTC - 0 likes

    @lenis0012: Go

    @lenis0012:

    Thought I would pass you this stack trace: http://pastie.org/pastes/9722326/text

    I realize you don't directly support Cauldon, perhaps you could share with me a way around this issue though.

    Many Thanks.

    BFAK:90572240,474344991705deee14d355de6ad5b26280465c85414dd9c8d4e607e5e6e3f34e

  • Avatar of lenis0012 lenis0012 Nov 12, 2014 at 12:18 UTC - 0 likes

    @tjbruce: Go

    They cant publish the source code, thats my problem.

    On the bright side, the build server will be back soon!!! It will be available on ci.lenis0012.com

  • Avatar of sanjay900 sanjay900 Nov 10, 2014 at 02:29 UTC - 0 likes

    I only removed tab, which is probably why tjbruce is having problems... I had no idea on how to update the api for it, because i didnt want to add a new api for the tab since it has completely changed. Appearently my fix works for MyWorlds too...

  • Avatar of tjbruce tjbruce Nov 08, 2014 at 10:03 UTC - 0 likes

    @lenis0012: Go

    Code for Spigot 1.8 is coming out soon. spigotmc.org Hopefully this will solve my Citizens Tablist issue. :D

  • Avatar of lenis0012 lenis0012 Nov 07, 2014 at 07:17 UTC - 1 like

    @sanjay900: Go

    Removing components from the plugin is not the proper way to update it :P
    But it will do for users of PortalStick

    The problem preventing me to support 1.8 is that Spinot is not updated to it.
    I dont have source code of spigot 1.8, so i cannot build Spinot based on it

    Last edited Nov 07, 2014 by lenis0012
  • Avatar of sanjay900 sanjay900 Nov 04, 2014 at 08:19 UTC - 0 likes

    @tjbruce: Go

    https://eyrenetwork.net/BKCommonLib-1.59-SNAPSHOT.jar

    Have an unofficial build, i made this because i needed bk for 1.8.

    @AngellitoX: Go

    The official builds aren't for 1.8, mine are. that's why mine won't have errors with 1.8, while the official builds probably will.

    Last edited Nov 04, 2014 by sanjay900
  • Avatar of tjbruce tjbruce Nov 02, 2014 at 03:15 UTC - 0 likes

    Is an update for Spigot 1.8/1.7.X coming out soon?

  • Avatar of lenis0012 lenis0012 Oct 31, 2014 at 07:31 UTC - 0 likes

    @AngellitoX: Go

    Like i said,
    Not compatible with 1.8 spigot hack

  • Avatar of AngellitoX AngellitoX Oct 29, 2014 at 02:20 UTC - 0 likes

    Hello there. I'm getting an error on startup. Here you can see it:

    http://pastebin.com/bqtTF07j

    I'm using Spigot-1.7.9-R0.2-207-g03373bb (MC: 1.7.10) (Implementing API version 1.7.10-R0.1-SNAPSHOT

    I hope you can help me lenis. Thank you so much for the further help!

    EDIT: I'm not sure if this can help but just to add, in the unofficial update sanjay900 uploaded I don't get this error. It only happens with the official one. Thank you

    Last edited Oct 29, 2014 by AngellitoX
  • Avatar of lenis0012 lenis0012 Oct 28, 2014 at 15:48 UTC - 1 like

    @tjbruce: Go

    We do not have direct spport for Citizens.
    It looks like a bug in Citizens to me tho.

    If you cant resolve it you may want to look for an alternative for Citizens if its not very important to you

Facts

Date created
Sep 18, 2012
Category
Last update
Oct 27, 2014
Development stage
Release
Language
  • enUS
License
GNU General Public License version 3 (GPLv3)
Curse link
BKCommonLib
Downloads
961,670
Recent files
  • R: v1.59 (1.7.10) for CB 1.7.9-R0.2 Oct 27, 2014
  • R: v1.58 for CB 1.7.9-R0.1 May 21, 2014
  • R: v1.57 for CB 1.7.2-R0.2 Jan 26, 2014
  • R: v1.56 for CB 1.6.4-R2.0 Nov 17, 2013
  • R: v1.55 for 1.6.4 Sep 30, 2013

Authors